package mslinks.extra;

import io.ByteReader;
import io.ByteWriter;

import java.io.IOException;
import java.util.LinkedList;

import mslinks.Serializable;
import mslinks.ShellLinkException;

public class VistaIDList implements Serializable {

	public static final int signature = 0xA000000C;
	
	private LinkedList<byte[]> list = new LinkedList<>();
	
	public VistaIDList(ByteReader br, int size) throws ShellLinkException, IOException {
		if (size < 0xa)
			throw new ShellLinkException();
		
		int s = (int)br.read2bytes();
		while (s != 0) {
			s -= 2;
			byte[] b = new byte[s];
			for (int i=0; i<s; i++)
				b[i] = (byte)br.read();
			list.add(b);
			s = (int)br.read2bytes();
		}		
	}
	
	@Override
	public void serialize(ByteWriter bw) throws IOException {
		int size = 10;
		for (byte[] i : list)
			size += i.length + 2;
		bw.write2bytes(size);
		for (byte[] i : list) {
			bw.write2bytes(i.length + 2);
			for (byte j : i)
				bw.write(j);
		}
		bw.write2bytes(0);
	}

}
